<!-- 海康威视组件 -->
<template>
  <BasicModal v-bind="$attrs" @register="registerModal" title="视频监控" @cancel="closeMonitor">
    <div>{{ monitorInfo ? monitorInfo.name : '' }}</div>
    <div id="playWnd" class="playWnd"></div>
  </BasicModal>
</template>

<script setup lang="ts">
  import { reactive, onMounted, onDeactivated, watch, onActivated, ref } from 'vue';
  import { useRouter } from 'vue-router';
  import { BasicModal, useModalInner } from '@/components/Modal';

  const monitorInfo = ref();
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    setModalProps({ confirmLoading: false });
    console.log(data);
    // monitorInfo.value.appSecret
    let obj: any = {
      name: data.name,
      card: data.deviceId,
    };
    if (data.rtuId == '374488578232389') {
      obj.appKey = '21274765';
      obj.ip = '223.99.16.253';
      obj.port = 1443;
      obj.appSecret = 'CraRtGvpNB2xOcYSFTov';
    } else if (data.rtuId == '382569943420997') {
      obj.appKey = '20252015';
      obj.ip = '60.213.12.166';
      obj.port = 2443;
      obj.appSecret = 'tGJdjmKxKxVWtzp1M6px';
    }
    monitorInfo.value = obj;
    console.log(obj);
    initPlugin();
  });
  const WebControl = window.WebControl; //index.html引入 直接从window里面拿到sdk
  const JSEncrypt = window.JSEncrypt; //index.html引入 直接从window里面拿到sdk
  const state = reactive({
    id: 'playWnd', //多个监控同时显示需要不同的id
    idWidth: 480,
    idHeight: 230,
    initCount: 0,
    pubKey: '',
    oWebControl: null as any,
  });
  console.log(state);
  //创建播放实例
  const initPlugin = () => {
    console.log('initPlugin');

    state.oWebControl = new WebControl({
      szPluginContainer: state.id, // 指定容器id
      iServicePortStart: 15900, // 指定起止端口号，建议使用该值
      iServicePortEnd: 15900,
      szClassId: '23BF3B0A-2C56-4D97-9C03-0CB103AA8F11', // 用于IE10使用ActiveX的clsid
      cbConnectSuccess: function () {
        // 创建WebControl实例成功
        state.oWebControl
          .JS_StartService('window', {
            // WebControl实例创建成功后需要启动服务
            dllPath: './VideoPluginConnect.dll', // 值"./VideoPluginConnect.dll"写死
          })
          .then(
            () => {
              console.log('启动成功');
              // 启动插件服务成功
              state.oWebControl.JS_SetWindowControlCallback({
                // 设置消息回调
                cbIntegrationCallBack: cbIntegrationCallBack,
              });

              state.oWebControl.JS_CreateWnd('playWnd', 480, 230).then(() => {
                //JS_CreateWnd创建视频播放窗口，宽高可设定
                init(); // 创建播放实例成功后初始化
              });
            },
            function () {
              console.log('启动失败');
              // 启动插件服务失败
            },
          );
      },
      cbConnectError: function () {
        // 创建WebControl实例失败
        state.oWebControl = null;
        console.log('插件未启动，正在尝试启动，请稍候...');
        WebControl.JS_WakeUp('VideoWebPlugin://'); // 程序未启动时执行error函数，采用wakeup来启动程序
        state.initCount++;
        if (state.initCount < 3) {
          setTimeout(function () {
            initPlugin();
          }, 3000);
        } else {
          console.log('插件启动失败，请检查插件是否安装！');
        }
      },
      cbConnectClose: function (bNormalClose) {
        // 异常断开：bNormalClose = false
        // JS_Disconnect正常断开：bNormalClose = true
        console.log('cbConnectClose');
      },
    });
  };
  // 设置窗口控制回调
  const setCallbacks = () => {
    state.oWebControl.JS_SetWindowControlCallback({
      cbIntegrationCallBack: cbIntegrationCallBack,
    });
  };

  // 推送消息
  const cbIntegrationCallBack = (oData) => {
    console.log(oData, '--oData');
  };

  //初始化
  const init = () => {
    console.log('init');
    getPubKey(() => {
      console.log('getPubKey');

      // 请自行修改以下变量值
      var playMode = 0; //初始播放模式：0-预览，1-回放
      var snapDir = 'D:\\SnapDir'; //抓图存储路径
      var videoDir = 'D:\\VideoDir'; //紧急录像或录像剪辑存储路径
      var layout = '1x1'; //playMode指定模式的  布局
      var enableHTTPS = 1; //是否启用HTTPS协议与综合安防管理平台交互，这里总是填1
      var encryptedFields = 'secret'; //加密字段，默认加密领域为secret
      var showToolbar = 1; //是否显示工具栏，0-不显示，非0-显示
      var showSmart = 1; //是否显示智能信息（如配置移动侦测后画面上的线框），0-不显示，非0-显示
      var buttonIDs = '0,16,256,257,258,259,260,512,513,514,515,516,517,768,769'; //自定义工具条按钮
      // 请自行修改以上变量值
      console.log(monitorInfo.value);
      state.oWebControl
        .JS_RequestInterface({
          funcName: 'init',
          argument: JSON.stringify({
            appkey: monitorInfo.value.appKey, //API网关提供的appkey
            secret: monitorInfo.value.appSecret, //API网关提供的secret
            ip: monitorInfo.value.ip, //API网关IP地址
            playMode: playMode, //播放模式（决定显示预览还是回放界面）
            port: monitorInfo.value.port, //端口
            snapDir: snapDir, //抓图存储路径
            videoDir: videoDir, //紧急录像或录像剪辑存储路径
            layout: layout, //布局
            enableHTTPS: enableHTTPS, //是否启用HTTPS协议
            // encryptedFields: encryptedFields, //加密字段
            showToolbar: showToolbar, //是否显示工具栏
            showSmart: showSmart, //是否显示智能信息
            buttonIDs: buttonIDs, //自定义工具条按钮
          }),
        })
        .then(function (oData: any) {
          console.log(oData, 'oData');
          state.oWebControl.JS_Resize(state.idWidth, state.idHeight); // 初始化后resize一次，规避firefox下首次显示窗口后插件窗口未与DIV窗口重合问题
        });
      previewClick();
    });
  };

  //获取公钥
  const getPubKey = (callback: any) => {
    state.oWebControl
      .JS_RequestInterface({
        funcName: 'getRSAPubKey',
        argument: JSON.stringify({
          keyLength: 1024,
        }),
      })
      .then((oData: { responseMsg: { data: string } }) => {
        console.log(oData);
        if (oData.responseMsg.data) {
          state.pubKey = oData.responseMsg.data;
          callback();
        }
      });
  };

  //RSA加密
  const setEncrypt = (value: string) => {
    var encrypt = new JSEncrypt();
    encrypt.setPublicKey(state.pubKey);
    return encrypt.encrypt(value);
  };

  // 监听resize事件，使插件窗口尺寸跟随DIV窗口变化
  window.addEventListener('resize', () => {
    if (state.oWebControl != null) {
      state.oWebControl.JS_Resize(state.idWidth, state.idHeight);
      // setWndCover();
    }
  });

  // 监听滚动条scroll事件，使插件窗口跟随浏览器滚动而移动
  window.addEventListener('scroll', () => {
    if (state.oWebControl != null) {
      state.oWebControl.JS_Resize(state.idWidth, state.idHeight);
      // setWndCover();
    }
  });

  //视频预览功能
  const previewClick = () => {
    console.log('previewClick');
    var streamMode = 0; //主子码流标识：0-主码流，1-子码流
    var transMode = 1; //传输协议：0-UDP，1-TCP
    var gpuMode = 0; //是否启用GPU硬解，0-不启用，1-启用
    var wndId = -1; //播放窗口序号（在2x2以上布局下可指定播放窗口）

    state.oWebControl.JS_RequestInterface({
      funcName: 'startPreview',
      argument: JSON.stringify({
        cameraIndexCode: monitorInfo.value.card, //监控点编号
        streamMode: streamMode, //主子码流标识
        transMode: transMode, //传输协议
        gpuMode: gpuMode, //是否开启GPU硬解
        wndId: wndId, //可指定播放窗口
      }),
    });
    console.log(state.oWebControl.JS_RequestInterface, ' ------face');
    console.log('执行完成');
  };

  onActivated(() => {
    initPlugin();
  });
  onDeactivated(() => {
    console.log('销毁了');
    state.oWebControl.JS_HideWnd();
    state.oWebControl.JS_Disconnect().then(
      function () {
        //断开与插件服务连接成功
        console.log('断开与插件服务连接成功');
      },
      function () {
        //断开与插件服务连接失败
        console.log('断开与插件服务连接失败');
      },
    );
  });
  function closeMonitor() {
    console.log('销毁了');
    state.oWebControl.JS_HideWnd();
    state.oWebControl.JS_Disconnect().then(
      function () {
        //断开与插件服务连接成功
        console.log('断开与插件服务连接成功');
      },
      function () {
        //断开与插件服务连接失败
        console.log('断开与插件服务连接失败');
      },
    );
    closeModal();
  }
</script>
<style lang="less" scoped>
  .playWnd {
    width: 100%;
    height: 20vh;
    margin-top: 4px;
  }
</style>
